VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cListener"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the object that represents the listener
Public DS3Dlistener As DirectSound3DListener8
 





' this function creates a listener from a primary sound buffer
Function Init() As Boolean
' temp objects used to create the listener
Dim BufferDesc As DSBUFFERDESC
Dim Buffer As DirectSoundPrimaryBuffer8
Dim waveFormat As WAVEFORMATEX
On Error GoTo InitFailed
    ' create primary sound buffer
    BufferDesc.lFlags = DSBCAPS_CTRL3D Or DSBCAPS_PRIMARYBUFFER
    Set Buffer = DS.CreatePrimarySoundBuffer(BufferDesc)
    If Buffer Is Nothing Then GoTo InitFailed
    ' create the listener
    Set DS3Dlistener = Buffer.GetDirectSound3DListener
    If DS3Dlistener Is Nothing Then GoTo InitFailed
    Init = Not Err.Number
    Exit Function
InitFailed:
End Function



' this sets the position of the listeners head
Sub SetOrientation(topVector As D3DVECTOR, frontVector As D3DVECTOR, Optional applyFlags As CONST_DS3DAPPLYFLAGS = DS3D_IMMEDIATE)
On Error Resume Next
    DS3Dlistener.SetOrientation frontVector.x, frontVector.y, frontVector.z, topVector.x, topVector.y, topVector.z, applyFlags
End Sub



' sets the position of the listener
Sub SetPosition(newPosition As D3DVECTOR, Optional applyFlags As CONST_DS3DAPPLYFLAGS = DS3D_IMMEDIATE)
On Error Resume Next
    DS3Dlistener.SetPosition newPosition.x, newPosition.y, newPosition.z, applyFlags
End Sub



' sets the velocity of the sound
Sub SetVelocity(newVelocity As D3DVECTOR, Optional applyFlags As CONST_DS3DAPPLYFLAGS = DS3D_IMMEDIATE)
On Error Resume Next
    DS3Dlistener.SetVelocity newVelocity.x, newVelocity.y, newVelocity.z, applyFlags
End Sub



' updates any deffered settings
Sub Update()
On Error Resume Next
    DS3Dlistener.CommitDeferredSettings
End Sub
