VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cMouse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Option Explicit

' the direct input device, in this class, a mouse
Public DIdevice As DirectInputDevice8
' the current state of the mouse
Private State As DIMOUSESTATE

' possible mouse buttons
Public Enum MOUSE_BUTTONS
    LEFT_BUTTON = 0
    RIGHT_BUTTON = 1
    MIDDLE_BUTTON = 2
End Enum





' aquires a mouse device
Function Init(hWnd As Long, Optional ForegroundOnly As Boolean = True) As Boolean
On Error GoTo InitFailed
    Set DIdevice = DI.CreateDevice("guid_SysMouse")
    If DIdevice Is Nothing Then Exit Function
    DIdevice.SetCommonDataFormat DIFORMAT_MOUSE
    If ForegroundOnly Then
        DIdevice.SetCooperativeLevel hWnd, DISCL_EXCLUSIVE Or DISCL_FOREGROUND
    Else
        DIdevice.SetCooperativeLevel hWnd, DISCL_NONEXCLUSIVE Or DISCL_BACKGROUND
    End If
    DIdevice.Acquire
    Refresh
    Init = Not Err.Number
    Exit Function
InitFailed:
End Function



' updates the information in the state buffer
Sub Refresh()
On Error Resume Next
    DIdevice.GetDeviceStateMouse State
End Sub



' get x, y and z coordinates
Property Get x() As Long
On Error Resume Next
    x = State.lX
End Property
Property Get y() As Long
On Error Resume Next
    y = State.lY
End Property
Property Get z() As Long
On Error Resume Next
    z = State.lZ
End Property



' get mouse buttons
Property Get ButtonIsDown(Button As MOUSE_BUTTONS) As Boolean
On Error Resume Next
    ButtonIsDown = State.Buttons(Button)
End Property
